import { CallHandler, ExecutionContext, Injectable, NestInterceptor } from "@nestjs/common";
import { createCorrelationId } from "@src/libs/utils/correlationId";
import { Observable, tap } from "rxjs";
import { RequestContextService } from './AppRequestContext';

@Injectable()
export class ContextInterceptor implements NestInterceptor {
  intercept(context: ExecutionContext, next: CallHandler<any>): Observable<any> | Promise<Observable<any>> {
    const request = context.switchToHttp().getRequest();

    const requestId = request?.body?.requestId ?? createCorrelationId(6);

    RequestContextService.setRequestId(requestId);

    return next.handle().pipe(
      tap(() => {
        // perform cleaning if needed
      })
    )
  }
}