import { Controller } from "@nestjs/common";
import { CommandBus } from "@nestjs/cqrs";
import { MessagePattern } from "@nestjs/microservices";
import { UserResponseDto } from "../dtos/user.response.dto";
import { CreateUserCommand } from "./create-user.command";
import { CreateUserRequestDto } from "./create-user.request.dto";

@Controller()
export class CreateUserMessageController {
  constructor(private readonly commandBus: CommandBus) {}

  @MessagePattern('user.create')
  async create(message: CreateUserRequestDto): Promise<string> {
    const command = new CreateUserCommand(message);

    const id: string = await this.commandBus.execute(command);

    return id;
  }
}