import { IsEmail, IsNotEmpty, IsNumber, IsString, MaxLength, MinLength, } from "class-validator";

export class CreateUserRequestDto {
 @IsEmail()
 readonly email: string;
 
 @IsNotEmpty()
 @MaxLength(14)
 @MinLength(10)
 readonly phone_number: string
 
 @IsNotEmpty()
 readonly fullname: string;
 
 @IsNotEmpty()
 readonly password: string;
 
 @IsNumber()
 @IsNotEmpty()
 readonly role_id: number;
}