import { DomainEvent, DomainEventProps } from "@src/libs/ddd";

export class UserCreatedDomainEvent extends DomainEvent {
  readonly email: string;
  readonly phone_number: string;
  readonly password: string;
  readonly fullname: string;
  readonly role_id: number;

  constructor(props: DomainEventProps<UserCreatedDomainEvent>) {
    super(props);
    this.email = props.email;
    this.phone_number = props.phone_number;
    this.password = props.password;
    this.fullname = props.fullname;
    this.role_id = props.role_id;
  }
}